var _excluded = ["style", "className", "span", "children", "flex"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useContext } from 'react';
import clsx from 'clsx';
import FlexContext from './FlexContext';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var FlexItem = function FlexItem(props) {
  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('flexitem', prefixCls),
      bem = _createNamespace[0];

  var style = props.style,
      className = props.className,
      span = props.span,
      children = props.children,
      flex = props.flex,
      others = _objectWithoutPropertiesLoose(props, _excluded);

  var classes = clsx(bem([span == null ? void 0 : span.toString()]), className);

  var parseFlex = function parseFlex(_flex) {
    if (typeof _flex === 'number') {
      return _flex + " " + _flex + " auto";
    }

    if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(_flex)) {
      return "0 0 " + _flex;
    }

    return _flex;
  };

  return /*#__PURE__*/React.createElement(FlexContext.Consumer, null, function (_ref) {
    var gutter = _ref.gutter;

    var mergedStyle = _extends({}, style);

    if (gutter) {
      mergedStyle = _extends({}, gutter[0] > 0 ? {
        paddingLeft: gutter[0] / 2,
        paddingRight: gutter[0] / 2
      } : {}, gutter[1] > 0 ? {
        paddingTop: gutter[1] / 2,
        paddingBottom: gutter[1] / 2
      } : {}, mergedStyle);
    }

    if (flex) {
      mergedStyle.flex = parseFlex(flex);
    }

    return /*#__PURE__*/React.createElement("div", _extends({}, others, {
      style: mergedStyle,
      className: classes
    }), children);
  });
};

export default FlexItem;